Index: mscore/mscore/actions.cpp
===================================================================
--- mscore/mscore/actions.cpp	(revisione 5535)
+++ mscore/mscore/actions.cpp	(copia locale)
@@ -2940,7 +2940,17 @@
          QT_TRANSLATE_NOOP("action","Insert Measure"),
          measure_ICON
          ),
-      Shortcut(
+    Shortcut(
+       STATE_NORMAL | STATE_NOTE_ENTRY,
+       A_CMD,
+       "add-marcato",
+       QT_TRANSLATE_NOOP("action","Add marcato"),
+       Qt::CTRL+Qt::ALT+Qt::Key_O,
+       Qt::WindowShortcut,
+       QT_TRANSLATE_NOOP("action","Marcato"),
+       QT_TRANSLATE_NOOP("action","Add Marcato")
+       ),
+    Shortcut(
          STATE_NORMAL,
          0,
          "viewmode",
Index: mscore/mscore/revision.h
===================================================================
--- mscore/mscore/revision.h	(revisione 5535)
+++ mscore/mscore/revision.h	(copia locale)
@@ -1 +1 @@
-5524:5526M
\ No newline at end of file
+5535M
\ No newline at end of file
Index: mscore/mscore/scoreview.cpp
===================================================================
--- mscore/mscore/scoreview.cpp	(revisione 5535)
+++ mscore/mscore/scoreview.cpp	(copia locale)
@@ -2494,6 +2494,8 @@
             sm->postEvent(new CommandEvent(cmd));
       else if (cmd == "add-slur")
             cmdAddSlur();
+//      else if (cmd == "add-marcato")
+//            cmdAddMarcato();
       else if (cmd == "note-c")
             cmdAddPitch(0, false);
       else if (cmd == "note-d")
@@ -2522,6 +2524,8 @@
             cmdAddPitch(5, true);
       else if (cmd == "chord-b")
             cmdAddPitch(6, true);
+      else if (cmd == "marcato")
+            cmdAddPitch(7, true);
       else if (cmd == "insert-c")
             cmdInsertNote(0);
       else if (cmd == "insert-d")
@@ -2536,6 +2540,8 @@
             cmdInsertNote(5);
       else if (cmd == "insert-b")
             cmdInsertNote(6);
+      else if (cmd == "insert-m")
+            cmdInsertNote(7);
       else if (cmd == "chord-text")
             cmdAddChordName();
 
@@ -4662,12 +4668,28 @@
       qDebug("not implemented: cmdInsertNote %d", note);
       }
 
+
 //---------------------------------------------------------
 //   cmdAddPitch
 //    c d e f g a b entered:
 //       insert note or add note to chord
 //---------------------------------------------------------
 
+
+//void Marcato::cmdAddMarcato()
+//{
+//    char* marcato = "^";
+//    Marcato* marcato = _score->
+
+//}
+
+
+//---------------------------------------------------------
+//   cmdAddPitch
+//    c d e f g a b marcato entered:
+//       insert note, marcato or add note to chord
+//---------------------------------------------------------
+
 void ScoreView::cmdAddPitch(int note, bool addFlag)
       {
       InputState& is = _score->inputState();
@@ -4676,7 +4698,7 @@
       Drumset* ds = is.drumset();
       int pitch;
       if (ds) {
-            char note1 = "CDEFGAB"[note];
+            char note1 = "CDEFGABM"[note];
             pitch = -1;
             for (int i = 0; i < 127; ++i) {
                   if (!ds->isValid(i))
@@ -4762,6 +4784,7 @@
                         }
                   s = new Text(_score);
                   switch(type) {
+
                         case TEXT_TITLE:    s->setTextStyle(_score->textStyle(TEXT_STYLE_TITLE));    break;
                         case TEXT_SUBTITLE: s->setTextStyle(_score->textStyle(TEXT_STYLE_SUBTITLE)); break;
                         case TEXT_COMPOSER: s->setTextStyle(_score->textStyle(TEXT_STYLE_COMPOSER)); break;
Index: mscore/mscore/articulation.ui
===================================================================
--- mscore/mscore/articulation.ui	(revisione 5535)
+++ mscore/mscore/articulation.ui	(copia locale)
@@ -7,7 +7,7 @@
     <x>0</x>
     <y>0</y>
     <width>500</width>
-    <height>346</height>
+    <height>358</height>
    </rect>
   </property>
   <property name="windowTitle">
Index: mscore/bww2mxml/symbols.cpp
===================================================================
--- mscore/bww2mxml/symbols.cpp	(revisione 5535)
+++ mscore/bww2mxml/symbols.cpp	(copia locale)
@@ -46,7 +46,8 @@
     "DOT",
     "GRACE",
     "UNKNOWN",
-    "NONE"
+    "NONE",
+    "MARCATO"
   };
 
   QString symbolToString(Symbol s)
Index: mscore/bww2mxml/symbols.h
===================================================================
--- mscore/bww2mxml/symbols.h	(revisione 5535)
+++ mscore/bww2mxml/symbols.h	(copia locale)
@@ -46,7 +46,8 @@
     DOT,
     GRACE,
     UNKNOWN,
-    NONE
+    NONE,
+    MARCATO
   };
 
   enum StartStop
Index: mscore/libmscore/cmd.cpp
===================================================================
--- mscore/libmscore/cmd.cpp	(revisione 5535)
+++ mscore/libmscore/cmd.cpp	(copia locale)
@@ -2537,8 +2537,12 @@
             }
 	else if (cmd == "add-staccato")
             addArticulation(Articulation_Staccato);
-	else if (cmd == "add-tenuto")
+    else if (cmd == "add-marcato")
+            addArticulation(Articulation_Marcato);
+    else if (cmd == "add-tenuto")
             addArticulation(Articulation_Tenuto);
+    else if (cmd == "add-marcato")
+            addArticulation(Articulation_Marcato);
 	else if (cmd == "add-trill")
             addArticulation(Articulation_Trill);
       else if (cmd == "add-hairpin")