Index: mscore/awl/CMakeLists.txt
===================================================================
--- mscore/awl/CMakeLists.txt	(Revision 2789)
+++ mscore/awl/CMakeLists.txt	(Arbeitskopie)
@@ -98,16 +98,18 @@
       slider.h
       volslider.h
       mslider.h
       denomspinbox.h
       pitchedit.h
       pitchlabel.h
       )
 
+if (BUILD_AWL_PLUGIN)
+
 add_library (
       awlplugin SHARED
       ${PROJECT_BINARY_DIR}/all.h
       ${PROJECT_BINARY_DIR}/all.h.pch
       ${mocs2}
       awlplugin.cpp
       aslider.cpp
       knob.cpp
@@ -132,10 +134,11 @@
             "-D_GNU_SOURCE -D_REENTRANT -DHAVE_CONFIG_H -DQT_PLUGIN -DQT_SHARED -DQT_NO_DEBUG -include ${PROJECT_SOURCE_DIR}/all.h"
       )
 
 install( TARGETS awlplugin DESTINATION ${QT_PLUGINS_DIR}/designer/ )
 
 add_executable(ltest ltest.cpp)
 target_link_libraries (ltest awlplugin ${QT_LIBRARIES})
 
+endif (BUILD_AWL_PLUGIN)
 
 endif (NOT MINGW AND NOT APPLE)
Index: mscore/CMakeLists.txt
===================================================================
--- mscore/CMakeLists.txt	(Revision 2789)
+++ mscore/CMakeLists.txt	(Arbeitskopie)
@@ -26,19 +26,21 @@
 # for debugging the make system uncomment next line:
 # set(CMAKE_VERBOSE_MAKEFILE ON)
 
 set(MSCORE_UNSTABLE  TRUE)                # mark as unstable
 
 set(GCC_VISIBILITY TRUE)                  # requires gcc 4.x?
 set(HAS_AUDIOFILE TRUE)                   # requires libsndfile
 
-set(STATIC_SCRIPT_BINDINGS FALSE)
+set(STATIC_SCRIPT_BINDINGS TRUE)
 set(USE_SSE FALSE)
 
+set(BUILD_AWL_PLUGIN FALSE)
+
 if (MINGW)
       set(GCC_VISIBILITY FALSE)           # we use gcc 3.6
       set(STATIC_SCRIPT_BINDINGS TRUE)
 endif (MINGW)
 
 if (APPLE)
       set(HAS_AUDIOFILE TRUE)            # requires libsndfile
       set(STATIC_SCRIPT_BINDINGS TRUE)
@@ -54,16 +56,25 @@
       set(OsxFrameworks ${AudioToolboxFW} ${AudioUnitFW} ${CoreAudioFW} ${CoreMidiFW} ${SystemConfigurationFW} ${CoreServicesFW})
 endif (APPLE)
 
 set(CMAKE_INCLUDE_CURRENT_DIR TRUE)
 set(CMAKE_BUILD_WITH_INSTALL_RPATH ON)
 set(CMAKE_SKIP_RULE_DEPENDENCY TRUE)
 
 # The Mscore version number.
+
+SET(Mscore_REVISION "")
+
+FIND_PACKAGE(Subversion)
+      IF (Subversion_FOUND)
+            Subversion_WC_INFO(${PROJECT_SOURCE_DIR} mscore)
+            SET(Mscore_REVISION "~r${mscore_WC_REVISION}")
+      ENDIF(Subversion_FOUND)
+
 SET(Mscore_VERSION_MAJOR  "0")
 SET(Mscore_VERSION_MINOR  "9")
 SET(Mscore_VERSION_PATCH  "6")
 
 SET(Mscore_VERSION       "${Mscore_VERSION_MAJOR}.${Mscore_VERSION_MINOR}")
 SET(Mscore_VERSION_FULL  "${Mscore_VERSION}.${Mscore_VERSION_PATCH}")
 
 if (MINGW OR APPLE)
@@ -303,39 +314,39 @@
       ")
   ELSE(MINGW)
       SET(CPACK_PACKAGE_ICON "${PROJECT_SOURCE_DIR}/mscore/data/mscore.bmp")
       SET(CPACK_STRIP_FILES "mscore")
       SET(CPACK_SOURCE_STRIP_FILES "")
   ENDIF(MINGW)
 
   SET(CPACK_SOURCE_PACKAGE_FILE_NAME "mscore")
-  SET(CPACK_PACKAGE_FILE_NAME     "${CPACK_SOURCE_PACKAGE_FILE_NAME}-${Mscore_VERSION_FULL}")
+  SET(CPACK_PACKAGE_FILE_NAME     "${CPACK_SOURCE_PACKAGE_FILE_NAME}-${Mscore_VERSION_FULL}${Mscore_REVISION}")
   SET(CPACK_PACKAGE_EXECUTABLES   "mscore" "MuseScore")
 
   set(CPACK_DEBIAN_PACKAGE_NAME         "mscore")
-  set(CPACK_DEBIAN_PACKAGE_VERSION      "${Mscore_VERSION_FULL}-0ubuntu0.1")
+  set(CPACK_DEBIAN_PACKAGE_VERSION      "${Mscore_VERSION_FULL}${Mscore_REVISION}-0ubuntu0.1")
   set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "i386")
 
-  set(CPACK_DEBIAN_PACKAGE_DEPENDS    "libqt4-core (>= 4.4), libqt4-gui (>= 4.4)")
+  set(CPACK_DEBIAN_PACKAGE_DEPENDS    "libqt4-core (>= 4.6), libqt4-gui (>= 4.6)")
 
   set(CPACK_DEBIAN_PACKAGE_MAINTAINER   "tsmithe@ubuntu.com")
   set(CPACK_DEBIAN_PACKAGE_SECTION      "devel")
   set(CPACK_DEBIAN_PACKAGE_PRIORITY     "optional")
   set(CPACK_DEBIAN_PACKAGE_RECOMMENDS   "")
   set(CPACK_DEBIAN_PACKAGE_SUGGESTS     "")
 
   set(CPACK_PACKAGE_CONTACT       "ws@seh.de")
 
 if (MINGW)
   set(CPACK_GENERATOR             "NSIS")
   set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/packaging" ${CMAKE_MODULE_PATH}) # Use custom version of NSIS.InstallOptions.ini
 else (MINGW)
   if (NOT APPLE)
-    set(CPACK_GENERATOR             "DEB;TBZ2")
+    set(CPACK_GENERATOR             "DEB")
     set(CPACK_DEB "on")
   endif (NOT APPLE)
 endif (MINGW)
 
 include (CPack)
 
 add_custom_target(lupdate
    COMMAND ${PROJECT_SOURCE_DIR}/gen-qt-projectfile ${PROJECT_SOURCE_DIR} > mscore.pro
Index: Makefile
===================================================================
--- Makefile	(Revision 2789)
+++ Makefile	(Arbeitskopie)
@@ -117,20 +117,21 @@
 install:
 	cd build; make install
 
 #
 #  linux
 #     linux binary package build
 #
 unix:
-	if test ! -d linux;                          \
-         then                                      \
-            mkdir linux;                           \
-            cd linux
-            cmake -DCMAKE_BUILD_TYPE=RELEASE  ../mscore; \
-            make -j${CPUS} -f Makefile;            \
-            make package;                          \
-         else                                      \
-            echo "build directory linux does alread exist, please remove first";  \
-         fi
+	make revision;				\
+	if test ! -d linux;			\
+	 then					\
+	    mkdir linux;			\
+	fi;					\
+	cd linux;				\
+	cmake -DCMAKE_BUILD_TYPE=RELEASE	\
+	      -DCMAKE_INSTALL_PREFIX="/usr" ../mscore; \
+	make lrelease;				\
+	make -j${CPUS} -f Makefile;		\
+	make package
 
 